// Andrei Grigorean
// 100 pct

#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

#define FORIT(it, v) for (typeof((v).begin()) it = (v).begin(); it != (v).end(); ++it)

const int MAX_TESTS = 5;
const int MAX_N = 1000;

int global_A;
int n;
vector< pair<int, int> > sol;

inline void add_edge(int a, int b) {
    assert(1 <= a && a <= n);
    assert(1 <= b && b <= n);
    assert(a != b);
    sol.push_back(make_pair(a, b));
}

int query(int A, int B, int C) {
    assert(A != B and B != C and A != C);
    cout << "0 " << A << " " << B << " " << C << "\n";
    cout.flush();
    
    int ans;
    cin >> ans;
    return ans;
}

bool cmp(int a, int b) {
    if (a == b) return false;
    return query(global_A, a, b) == a;
}

void solve(vector<int> nodes) {
    if (nodes.size() == 1) return;
    if (nodes.size() == 2) {
        add_edge(nodes[0], nodes[1]);
        return;
    }
    int n = nodes.size();

    // Choose 2 random nodes
    int A = nodes[rand() % n];
    int B;
    do {
        B = nodes[rand() % n];
    } while (A == B);
    assert(A != B);

    vector<int> path;
    vector<int> query_ans(n);

    for (int i = 0; i < n; ++i)
        if (nodes[i] != A && nodes[i] != B) {
            query_ans[i] = query(A, B, nodes[i]);
            // Node is on A-B path
            if (query_ans[i] == nodes[i])
                path.push_back(nodes[i]);
        } else {
            if (nodes[i] == A) query_ans[i] = A;
            if (nodes[i] == B) query_ans[i] = B;
        }

    // Find path, use sort
    global_A = A;
    sort(path.begin(), path.end(), cmp);
    path.insert(path.begin(), A);
    path.push_back(B);
    for (size_t i = 0; i + 1 < path.size(); ++i)
        add_edge(path[i], path[i + 1]);

    vector< vector<int> > groups(path.size());
    for (int i = 0; i < n; ++i) {
        for (size_t j = 0; j < path.size(); ++j)
            if (path[j] == query_ans[i]) {
                groups[j].push_back(nodes[i]);
                break;
            }
    }
    FORIT(it, groups)
        solve(*it);
}

void print_tree() {
	cout << "1\n"; cout.flush();
	
    FORIT(it, sol) {
        cout << it->first << " " << it->second << "\n";
        cout.flush();
	}
}

int main() {
	srand (time (NULL));
    int tests;

    cin >> tests;
    assert(1 <= tests && tests <= MAX_TESTS);

    for (int test = 1; test <= tests; ++test) {
        cin >> n;
        assert(1 <= n && n <= MAX_N);

        vector<int> nodes;
        for (int i = 1; i <= n; ++i)
            nodes.push_back(i);
		sol.clear();
        solve(nodes);

        print_tree();
    }
}
