/* Andrei Parvu
   O(N + M), O(1) / query
*/

#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

#define NMAX 200000
#define lg 200005

pair<int, int> mx[lg][3];
pair<int, int> altmx[lg][2];

int A[lg], B[lg], C[lg], D[lg];
bool fst[lg];
vector<int> v[lg];
int res[lg];

int parent[lg];

vector<pair<int, int> > muchii;

void df(int nod) {
  fst[nod] = true;

  for (int i = 0; i < (int)v[nod].size(); i++) {
    if (fst[v[nod][i]] == false) {
      parent[v[nod][i]] = nod;
      df(v[nod][i]);

      A[nod] = max(A[nod], A[v[nod][i]] + 1);

      if (B[v[nod][i]] >= altmx[nod][0].first) {
        altmx[nod][1] = altmx[nod][0];
        altmx[nod][0] = make_pair(B[v[nod][i]], i);
      } else if (B[v[nod][i]] >= altmx[nod][1].first) {
        altmx[nod][1] = make_pair(B[v[nod][i]], i);
      }

      if (A[v[nod][i]] + 1 >= mx[nod][0].first) {
        mx[nod][2] = mx[nod][1];
        mx[nod][1] = mx[nod][0];
        mx[nod][0] = make_pair(A[v[nod][i]] + 1, i);
      } else if (A[v[nod][i]] + 1 >= mx[nod][1].first) {
        mx[nod][2] = mx[nod][1];
        mx[nod][1] = make_pair(A[v[nod][i]] + 1, i);
      } else if (A[v[nod][i]] + 1 >= mx[nod][2].first) {
        mx[nod][2] = make_pair(A[v[nod][i]] + 1, i);
      }

      B[nod] = max(B[nod], B[v[nod][i]]);
    }
  }

  B[nod] = max(B[nod], mx[nod][0].first + mx[nod][1].first);
}

void df2(int nod, int upcost, int allUp) {
  fst[nod] = false;

  C[nod] = upcost;
  D[nod] = allUp;

  if (D[nod] + 1 > C[nod]) {
    res[nod] = D[nod] + 1 + B[nod];
  } else {
    res[nod] = C[nod] + B[nod];
  }

  D[nod] = max(allUp, upcost);

  for (int i = 0; i < (int)v[nod].size(); i++) {
    if (fst[v[nod][i]] == true) {
      int mx1, mx2;

      if (mx[nod][0].second == i) {
        mx1 = mx[nod][1].first;
        mx2 = mx[nod][2].first;
      } else {
        mx1 = mx[nod][0].first;

        if (mx[nod][1].second == i) {
          mx2 = mx[nod][2].first;
        } else {
          mx2 = mx[nod][1].first;
        }
      }

      int altDrum;
      if (altmx[nod][0].second == i) {
        altDrum = altmx[nod][1].first;
      } else {
        altDrum = altmx[nod][0].first;
      }

      int drumSusFiu = upcost + mx1;
      int drumPrinNod = mx1 + mx2;

      df2(v[nod][i],
          max(upcost, mx1) + 1,
          max(max(D[nod], altDrum), max(drumSusFiu, drumPrinNod))
      );
    }
  }
}

int main() {
  freopen("plimbare.in", "rt", stdin);
  freopen("plimbare.out", "wt", stdout);

  int n, x, y;

  assert(scanf("%d", &n) == 1);
  assert(1 <= n && n <= NMAX);

  for (int i = 1; i < n; i++) {
    assert(scanf("%d %d", &x, &y) == 2);
    assert(1 <= x && x <= n && 1 <= y && y <= n);

    v[x].push_back(y);
    v[y].push_back(x);

    muchii.push_back(make_pair(x, y));
  }


  df(1);

  df2(1, 0, 0);

  for (int i = 0; i < (int)muchii.size(); i++) {
    if (parent[muchii[i].first] == muchii[i].second) {
      printf("%d\n", res[muchii[i].first]);
    } else {
      printf("%d\n", res[muchii[i].second]);
    }
  }

  return 0;
}

