#include <cstdio>
#include <algorithm>
#include <fstream>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <cassert>

#define pb push_back
#define mp make_pair
#define f first
#define s second
#define ll long long

// TO DO - change to long long

const int MAXN = 100005;
const int SQRTN = 105;
const int INF = 0x3f3f3f3f;

using namespace std;

int msqrt;

long long A[MAXN] , sum[SQRTN][SQRTN];
long long ansMin[MAXN];
int pozMin[MAXN];

int K , N; 
int st[SQRTN], dr[SQRTN];
long long cc[SQRTN], V[SQRTN][SQRTN];
int Size[SQRTN];
ll toadd = 0;


void debug() {
  
  for (int i = 1; i <= K; ++i) {
    for (int j = 0; j < Size[i]; ++j)
      cerr << sum[i][j] << " " ;
  }
  cerr << "\n";

}
int query() {
  
  int  pz = 0;
  ll f = 0;

//  cerr << N << " " << K << " " << sum[K][Size[K] - 1] << "\n"; 
 
  if (sum[K][Size[K] - 1] + toadd < 0)
    return -1;
  
  for (int i = 1; i <= K ; ++i) {
    if (ansMin[i] < f) {
      f = ansMin[i];
      pz = pozMin[i];
    }
  } 
//  cerr << "minimum sum " << f << "\n";
  return pz;
  
}
void my_insert(int pz, ll val) {
  int pf = 0;

  for (int i = 1; i <= K; ++i) 
     if (st[i] <= pz && dr[i] >= pz) {
       pf = i;
       break;
     }

  for (int i = 0 ; i < Size[pf]; ++i) {
    if (st[pf] + i == pz) {
      for (int j = Size[pf]; j > i; --j)
	  V[pf][j] = V[pf][j - 1];
      V[pf][i + 1] = val;
    }
    sum[pf][0] = sum[pf - 1][Size[pf - 1]] + V[pf][0];
    
    for (int j = 1; j <= Size[pf]; ++j)
      sum[pf][j] = sum[pf][j - 1] + V[pf][j];
  }
  
  toadd += val;
  if (pf == 0) {
    // insert at begin
    if (K == 0) {
      K = 1; 
    }

    pf = 1;
    
    for (int j = Size[1]; j > 0 ; --j)
      V[1][j] = V[1][j - 1];
    
    V[1][0] = val;
    sum[1][0] = V[1][0];

    for (int j = 1; j <= Size[pf] ; ++j)
      sum[1][j] = sum[1][j - 1] + V[1][j];
  }
  
  ansMin[pf] = INF;
  for (int j = 0; j < Size[pf]; ++j) {
    if (ansMin[pf] > sum[pf][j]) {
      ansMin[pf] = sum[pf][j];
      pozMin[pf] = st[pf] + j;
    }
  }
  
  Size[pf] += 1;
  dr[pf] += 1;
  for (int i = pf + 1 ; i <= K; ++i) { 
    st[i] += 1;
    dr[i] += 1;
    pozMin[i] += 1;
    ansMin[i] += val;
  }
}

void my_erase(int pz) {
  int pf = 1;

  for (int i = 1 ; i <= K ; ++i)
    if (st[i] <= pz && pz <= dr[i]) {
      pf = i;
      break;
    }

  ansMin[pf] = INF;

  int dif = pz - st[pf];
  toadd -= V[pf][dif];
  ll to = V[pf][dif];

  for (int i = dif; i < Size[pf] - 1; ++i)
    V[pf][i] = V[pf][i + 1];

  Size[pf] -= 1;
  
  sum[pf][0] = V[pf][0] + sum[pf - 1][Size[pf - 1] - 1];
  
  for (int i = 1 ; i < Size[pf] ; ++i)
    sum[pf][i] = sum[pf][i - 1] + V[pf][i];

  dr[pf] -= 1;
  
  for (int i = pf + 1; i <= K; ++i) {
    st[i] -= 1;
    dr[i] -= 1;
    ansMin[i] -= to;
    pozMin[i] -= 1;
  }

}
void reconstruct(int k) {
/*  
  cerr << "reconstruct...\n";
  cerr << "A: ";
*/
  toadd = 0;
  if (k == 1) {
    N = 0;
    for (int i = 1; i <= K; ++i) {
      for (int j = 0 ; j < Size[i] ; ++j) {
//	cerr << V[i][j] << " " ;
	A[N + j + 1] = V[i][j];
      }
      N += Size[i];
      Size[i] = 0;
    }
  }
  
/* for (int i = 1; i <= K; ++i)
    cerr << Size[i] << " " ;
  cerr << "\n";
*/

  msqrt = 0;
  
  while (msqrt * msqrt <= N)
    msqrt += 1;

  if (msqrt > 1)
    msqrt -= 1;

  K = N / msqrt + 1;

  if (K > N)
    K = N;
 for (int i = 1; i <= K; ++i) {
    
    ansMin[i] = INF;
    st[i] = msqrt * (i - 1) + 1;
    dr[i] = msqrt * i;
    
    
    for (int j = 0 ; j < dr[i] - st[i] + 1 && j + st[i] <= N; ++j) {
      Size[i] += 1;
      V[i][j] = A[st[i] + j];
      
      if (j == 0)
	sum[i][j] = sum[i - 1][Size[i - 1] - 1] + A[st[i]];
      
      if (j > 0)
	sum[i][j] = sum[i][j - 1] + A[st[i] + j];

      if (ansMin[i] > sum[i][j]) {
	ansMin[i] = sum[i][j];
	pozMin[i] = j + st[i];
      } 
    }
    if (Size[i] == 0) {
      K = i - 1;
      break;
    }
//   cerr << i << " " << st[i] << " " << dr[i] << " " << Size[i] << "\n";  
  }
 // cerr << "sir : " << N << " " << K << "bucati de" << msqrt <<  " : " ;
/*
 for (int i = 1; i <= N; ++i)
    cerr << A[i] << " ";
  cerr << "\n";
*/
}
int main() {
  ifstream cin("rotatii.in");
  ofstream cout("rotatii.out");
  
  int M;
  cin >> N >> M;
  
  for (int i = 1; i <= N; ++i)
    cin >> A[i];
  
  reconstruct(0) ;
  int cnt_op = 0;
  
  //cerr << msqrt << "\n" ;

  
  while (M--) {
    int op, where;
    ll value;
//    cerr << toadd << "\n";
//    reconstruct(1);
    if (cnt_op == K) {
      reconstruct(1);
      cnt_op = 0;
    }
  
    cin >> op;
    if (op == 0) {
      cin >> where >> value;
      my_insert(where, value); 
      cnt_op += 1;
  //   cerr << "Insert:\n"; 
    } else if (op == 1) {
      cin >> where ;
      my_erase(where);
      cnt_op += 1;
    //  cerr << "Erase:\n";
    } else if(op == 2) { 
      cout << query()  << "\n"; 
     // cerr << "Query:\n";
    }
  }
  return 0;
}
